;;   Variables dfinies  toutes fins utiles, et pour servir de cobayes...
;$   Variablen auf alle mglichen Arten definiert, als Versuchskaninchen...
;+   Variables defined for all intents and purposes, and as guinea pigs...

(defparameter    a    '(1 2 3 4 5 6))
(defparameter    b    '(1 (2 (3)) 4 (5 6) 7 8))
(defparameter    c    (append a b))
(defparameter    bb   '(1 (2 (3 (1 (2 (3 (1 (2 (3 (1 (2 (3 (1 (2 (3 (1 (2 (3 (1 (2 (3)) 4 (5 6) 7 8))) 4 (5 6) 7 8))) 4 (5 6) 7 8))) 4 (5 6) 7 8))) 4 (5 6) 7 8))) 4 (5 (1 (2 (3)) 4 (5 6) 7 8) 6) 7 8))) 4 (5 6) 7 8))
(defparameter    nn   36)
(defparameter    melo '((0 . 4) (2 . 4) (11 . 3) (1 . 4) (10 . 3)))
(defparameter    func1               ;type enveloppe, couples en paires pointes
  '((0 . 0) (0.5 . 1) (2 . 0.3) (10 . 0.85) (19.7 . 0)))
(defparameter    func2               ;type enveloppe, couples en listes
  '((0   0) (0.5   1) (2   0.3) (10   0.85) (19.7   0)))
(defparameter    x    '(une deu tro kat sin sis))
(defparameter    y    '(une (deu (tro)) kat (sin sis) set uit))
(defparameter    z    (append x y))
(defparameter    ldl  '((aaa bbb ccc)
                        (111 222 333)
                        (foo bar zut)))
(defparameter    tt   '((0 10 20 30) (1 11 21 31) (2 12 22 32) (3 13 23 33)))
(defparameter    alt
  '((c1 . un) (c2 . deu) (c3 kat ett rat) (c4 (ata cos tan) aco)))

(defvar common-lisp::*PathLocPed*
   (make-pathname :directory
          (pathname-directory *load-truename*)))      ; <--- PATH d'installation
(if (boundp (quote common-lisp::*pathcldlo*))
  (defvar common-lisp::*PathLocPedExo*
    (merge-pathnames "pedexo.d/" common-lisp::*pathcldlo*))
  (defvar common-lisp::*PathLocPedExo* "Undefined..."))

(when (not (fboundp 'jour-date))      ; <-- cl.d:+clinit.cl est-il dj charg ?
;;   Pour obtenir la date, sous forme d'une chane de caractres
;;    "Jour de la semaine, tantime/mois/anne, heures:minutes:secondes"
;; Possibilit de formatage  l'anglaise ou allemande avec un argument optionnel
;; e ou d respectivement [f ( la franaise) par dfaut].
;$   Um das Datum in Form einer Zeichenkette zu erhalten:
;$    "Wochentag, Tag.Monat.Jahr, Stunden:Minuten:Sekunden"
;$ Es ist mglich, die Wochentagsbezeichnungen und die Formatierung mit einem
;$ optionalen Argument e bzw. d [standardmig f (franzsisch)] englisch
;$ oder deutsch auszugeben.
;+   To obtain the date, as a character string
;+    "Week day, month/day/year, hours:minutes:seconds"
;+ Possibility of English or German week day's name and format with an optional
;+ argument e or d respectively [f (French) by default].
(defmacro jour-date (&optional (langue 'f) &aux separ jour)
  (let ((time (multiple-value-list (get-decoded-time))))
    (setq separ (if (eq 'd langue) "." "/"))
    (setq premi (if (eq 'e langue) (nth 4 time) (nth 3 time)))
    (setq secon (if (eq 'e langue) (nth 3 time) (nth 4 time)))
    (cond ((eq 'f langue) (setq jour (nth (nth 6 time)
            '("Lundi" "Mardi" "Mercredi" "Jeudi" "Vendredi" "Samedi"
              "Dimanche"))))
          ((eq 'd langue) (setq jour (nth (nth 6 time)
            '("Montag" "Dienstag" "Mittwoch" "Donnerstag" "Freitag"
              "Samstag" "Sontag"))))
          ((eq 'e langue) (setq jour (nth (nth 6 time)
            '("Monday" "Tuesday" "Wednesday" "Thursday" "Friday"
              "Saturday" "Sunday"))))
          (t (error "jour-date : langue inconnue : ~A." langue)))
    (format nil "~A, ~2,'0D~A~2,'0D~A~4D, ~2,'0D:~2,'0D:~2,'0D"
                jour
                premi separ secon separ (nth 5 time)
                (nth 2 time) (nth 1 time) (nth 0 time))))
)

(when (boundp 'Doc.) (setq Doc. (concatenate 'string Doc. ", Doc.Ped")))
(defparameter Doc.Ped (format nil "
;; Definitions
;    common-lisp::*PathLocPed*       => ~S
;    common-lisp::*PathLocPedExo*    => ~S
;    variables cobayes : a b c bb nn melo func1 func2 x y z ldl tt alt
;; Documentation
;    Doc.Ped (symb.)                 => ceci
"
        common-lisp::*PathLocPed* common-lisp::*PathLocPedExo*))

(when (not (boundp 'Doc.Clinit))
  (setq Doc.Ped (concatenate 'string Doc.Ped
                             (format nil ";; Utilitaire
;    jour-date                    => ...~%"))))

(format t "~A" Doc.Ped)

