(setq seqprob '(
	(1.0 0.0 0.0 0.0 0.0)
	(0.5 0.5 0.0 0.0 0.0)
	(0.0 0.5 0.5 0.0 0.0)
	(0.0 0.0 0.5 0.5 0.0)
	(0.0 0.0 0.0 0.5 0.5)
	(0.0 0.0 0.0 0.0 1.0)
))

(defun mel (linotes liseqprob &key (fois 20))
	(if (endp liseqprob) ()
	(labels ((soumel (liprob n)
				(if (zerop n) ()
				(cons (altern linotes liprob) (soumel liprob (1- n))))))
	(append	(soumel (car liseqprob) fois)
			(mel linotes (cdr liseqprob) :fois fois)))
))


;;	altern <boul> <prob>	=>	
;;		choix d'un element de la liste <boul>, selon les probabilites
;;		respectives donnees dans la liste <prob>.
;;		On ne verifie pas si <boul> et <prob> ont la meme list-length,
;;		ni si la somme des elements de la liste <prob> est egale a 0.0.
(defun altern (boul prob)
	(let (	(u (random 1.0)))
	(do*	(	(n 0 (1+ n))
				(som (nth 0 prob) (+ som (nth n prob))))
			((< u som) (nth n boul)))))
