(defun fract (a b &aux NN)
	(cond	((> a b) (fract b a))
			((= a b) (list b))
			((not (integerp (/ (- a b) 2)))
				(fract (+ a 1) b))
			(t  (setq NN	(if (= 1 (random 2))
								(+ a (/ (- a b ) 2))
							(- a (/ (- a b ) 2))))
				(cons NN (fract NN b)))))

(defun registre (note min max)
	(if	(or (> min note) (< max note))
			(+	min
				(mod note 12)
				(* (random (1+ (floor (/ (- max min) 12)))) 12))
	note))

(defun regli (li min max)
	(if (endp li) ()
	(cons	(midin>haut (registre (car li) min max))
			(regli (cdr li) min max))))

(defun melos1 (n1 n2 &key (min 24) (max 95))
	(regli (fract n1 n2) min max))

(setq nm-ht	'(										;NOMS_HAUT
		c c+
		d d+
		e
		f f+
		g g+
		a a+
		b
					))
(setq h/oc 12)
(setq h-rf 60)
(defun midin>haut (nnum)
	(and	(integerp nnum)
			(let ((a (- nnum h-rf)))
				(if (>= a 0) (cons	(nth (rem a h/oc) nm-ht)
									(floor (/ a h/oc)))
				(progn	(incf a)
						(cons	(nth	(1- (+ (rem a h/oc) h/oc))
										nm-ht)
	      						(1- (ceiling (/ a h/oc)))))))))
