;-- Vgl. [VAN WYMEERSCH, Brigitte, 1999: Descartes et l'volution de
;-- l'esthtique musicale, Mardaga]

;- S. 20: Tetraktys der antiken Pythagoreer, zwei getrennte Tetrachorde

           ;  C   G      ----      "Hypate"     "Paramese"
CL-USER 2 > (* 3/2
                8/9
           ;     F   C   ----      "Mese"       "Nete"
                  3/2 )
2
           ;  C   F      ----      "Hypate"     "Mese"
CL-USER 3 > (* 4/3
                9/8
           ;     G   C   ----      "Paramese"   "Nete"
                  4/3 )
2

;- S. 22, Funote 17: pythagoreere Skala, octochordales System

           ;  E   D   C       B   A   G   F       E
CL-USER 5 > (* 8/9 8/9 243/256 8/9 8/9 8/9 243/256 )
1/2
           ;  E       F   G   A   B       C   D   E   
CL-USER 6 > (* 256/243 9/8 9/8 9/8 256/243 9/8 9/8 )
2
CL-USER 7 > (apply #'* (reverse (mapcar #'(lambda (x) (/ 1 x))
                            '( 8/9 8/9 243/256 8/9 8/9 8/9 243/256 ))))
           ;                  E   D   C       B   A   G   F       E
2

;- S. 53: Quinte von Johannes Kepler

;- rationale: immer genau
CL-USER 12 > (+ 2/3 1/3)
1
;- schlechte Floats: ungefhr
CL-USER 13 > (+ 0.666666 0.333333)
0.9999989
;- bessere Floats: manchmal genau
CL-USER 14 > (float 2/3)
0.6666667
CL-USER 15 > (float 1/3)
0.33333334
CL-USER 16 > (+ (float 2/3) (float 1/3))
1.0

;- S. 70: 7 Oktave nicht gleichmig mit einem 12 Quintenzirkel

CL-USER 29 > (expt 2 7)
128
CL-USER 30 > (expt 3/2 12)
531441/4096
CL-USER 31 > (float (expt 3/2 12))
129.74634
CL-USER 35 > (/ (expt 3/2 12) (expt 2 7))
531441/524288
CL-USER 36 > (float 531441/524288)
1.0136433
CL-USER 37 > (* (log 531441/524288 2) 1200)
23.46001                                             ; <= Halbtne * 100 = Cents

;- S. 71: Temperierung Problem von Giovanni Battista Benedetti

            ;  E   C#     D
CL-USER 41 > (* 5/3  27/25 )
9/5
            ;  E   A   D
CL-USER 42 > (* 4/3 4/3 )
16/9
            ;  E   C#     D
CL-USER 43 > (* 5/3  16/15 )
16/9
            ;  E   C#     D-     D+                <= 81/80 = syntonisches Komma
CL-USER 44 > (* 5/3  16/15  81/80  )
9/5
CL-USER 45 > (/ 9/5 16/9)
81/80
CL-USER 46 > (* (log 81/80 2) 1200)
21.506289                       ; = syntonisches Komma <= Halbtne * 100 = Cents

;- S. 72, Funote 7: Temperierung Problem von Christian Huygens

            ;        C   G     D     A     E   C
CL-USER 51 > (/ (* (/ 2/3 3/4) (/ 2/3 3/4)) 4/5 )
80/81                                            ; <= 81/80 = syntonisches Komma
            ;  C   G   D   A   E   C
CL-USER 52 > (* 3/2 3/4 3/2 3/4 4/5 )
81/80
CL-USER 53 > (float 81/80)
1.0125
CL-USER 54 > (* (log 81/80 2) 1200)
21.506289                       ; = syntonisches Komma <= Halbtne * 100 = Cents
